﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EFEncrypt
{
    class Program
    {
        static void Main(string[] args)
        {
            using (var context = new Context())
            {
                context.People.Add(new Person
                {
                    DateOfBirth = new DateTime(2000, 1, 1).ToString(),
                    FirstName = "John",
                    LastName = "Doe",
                    SSN = "111-11-1111"
                });
                var changed = context.SaveChangesAsync().Result;
            }

            using (var context = new Context())
            {
                var people = context.People.ToList();
                context.Decrypt(people);
                foreach (var item in people)
                {
                    Console.WriteLine(item.LastName);
                }
            }

            using (var context = new Context())
            {
                var people = (from one in context.People
                              select new
                              {
                                  LastNameOfPerson = one.LastName
                              }).ToList().Select(one =>
                              {
                                  return new
                                  {
                                      LastNameOfPerson =
                                      string.IsNullOrEmpty(one.LastNameOfPerson)
                                            ? one.LastNameOfPerson
                                            : context.DecryptOneString(one.LastNameOfPerson)
                                  };
                              });

                foreach (var item in people)
                {
                    Console.WriteLine(item.LastNameOfPerson);
                }
            }
            Console.ReadKey();
        }
    }
}
